module System.Hardware.Joystick.Types
  ( Joystick(..)
  , JoystickEvent(..)
  ) where

import System.Hardware.Joystick.Internal

data Joystick = Joystick
  { joystickVersion :: Int
  , joystickButtons :: Int
  , joystickAxes    :: Int
  , joystickName    :: ByteString
  , joystickPoll    :: IO [JoystickEvent]
  , joystickClose   :: IO () }

data JoystickEvent
  = JoystickEventButton
      { joystickEventButtonIndex :: Int
      , joystickEventButtonPressed :: Bool }
  | JoystickEventAxis
      { joystickEventAxisIndex :: Int
      , joystickEventAxisValue :: Float }
  deriving (Show, Eq)

